=== utils/CMakeLists.txt ===
add_subdirectory(llvm-symbolizer)
