=== debian/changelog ===
clang (3.2-1~exp1ubuntu1) raring; urgency=low

  * Merge with Debian; remaining changes:
    - Default to softfp on armel.
    - Set vendor to Ubuntu, having slightly different defaults than Debian.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 21 Dec 2012 18:50:32 +0100

clang (3.2-1~exp1) experimental; urgency=low

  * New upstream release
  * Add Python as build dependency for Ubuntu

 -- Sylvestre Ledru <sylvestre@debian.org>  Thu, 20 Dec 2012 16:01:04 +0100
